﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'Source modification: DiskUtils V1.2 by JM November 2014

Sub Process_Globals
	Private fx As JFX
	Private DiskStatusChange As Timer
	Private OldDiskStatus As List
	Private caller As Object
End Sub

'Initializes Events if you need them
'Events will be handled in the caller module
'caller module will have to include subs DisksAdded_Event and DisksRemoved_Event wich will handle the events
'Example
'DiskUtils.InitializeEvents (Me, 5000)
'Will check for drives every 5 seconds
Sub InitializeEvents (module As Object,frequency As Int )
	caller = module
	OldDiskStatus.Initialize
	OldDiskStatus = GetDrives
	If DiskStatusChange.IsInitialized = False Then
		DiskStatusChange.Initialize ("DiskChange",frequency)
	End If
	DiskStatusChange.Enabled = True
End Sub

Sub TerminateEvents
	DiskStatusChange.Enabled = False
End Sub

' returns a list with all available drives in the system
Sub GetDrives As List
	Private lTotalDrives As List
	lTotalDrives.Initialize
	Private JObj1 As JavaObject
	JObj1.InitializeStatic("java.io.File")
	JObj1 = JObj1.RunMethod("listRoots",Null)
	Private Drives() As Object
	Drives = JObj1
	For i = 0 To Drives.Length-1
		lTotalDrives.Add(Drives(i).As(String).As(String))
	Next
	Return lTotalDrives
End Sub

'not to be called directly. Timer will handle this sub. Generates the Events
Private Sub DiskChange_tick
	DiskStatusChange.Enabled = False
	Private NewDiskStatus As List
	NewDiskStatus.Initialize
	NewDiskStatus = GetDrives
	
	If NewDiskStatus.Size<>OldDiskStatus.Size Then
		'newdrives detected
		If NewDiskStatus.Size>OldDiskStatus.Size Then
			'disks added
			CallSub (caller,"DisksAdded_Event")
		Else
			'disksremoved
			CallSub (caller,"DisksRemoved_Event")
		End If
	End If
	'No Change in Disks
	OldDiskStatus = GetDrives
	DiskStatusChange.Enabled = True
End Sub