﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
'Author: T201016
'Version: 1.0

#DesignerProperty: Key: EncryptMethod, DisplayName: Encrypt Method, FieldType: String, DefaultValue: SHA-512, List: MD5|SHA-1|SHA-224|SHA-256|SHA-384|SHA-512|NONE
#DesignerProperty: Key: Index, DisplayName: Index Value, FieldType: Int, DefaultValue: 0

'Updates
'V1.0
'Added new functions have been added to the project

Sub Class_Globals
	Dim encrypt_method As String
	Dim salt_value As String
	
	Dim Props As Map
	Private Items As Int
	Private DiskSerial As DiskUtil
End Sub

Public Sub Initialize
	ini_diskserial
	ini_properties
	set_encryptmethod
End Sub

Private Sub ini_properties
	Props.Initialize
	If File.Exists(File.DirApp, "properties.map") Then
		Props = File.ReadMap(File.DirApp, "properties.map")
	Else
		Props.Put("EncryptMethod", "MD5")
		Props.Put("Index", 0)
		Props.Put("ox", Main.ox)
		Props.Put("oy", Main.oy)
		File.WriteMap(File.DirApp, "properties.map", Props)
	End If
	get_properties
End Sub

Private Sub get_properties
	encrypt_method = Props.Get("EncryptMethod")
	Items = Props.Get("Index")
	Main.ox = Props.Get("ox")
	Main.oy = Props.Get("oy")
	salt_value = GenerateSalt(128)
End Sub

Private Sub ini_diskserial
	B4XDiskUtils.InitializeEvents (Me, 3000)
	DiskSerial.Initialize("DiskSerial")
	DiskSerial.getAllDrives
End Sub

Public Sub set_window (F As Form)
	f.WindowLeft = Main.ox
	f.WindowTop  = Main.oy
End Sub

Public Sub set_properties (F As Form)
	Props.Put("EncryptMethod",Main.cbEncryptMethod.Items.Get(Main.cbEncryptMethod.SelectedIndex))
	Props.Put("Index", Main.cbEncryptMethod.SelectedIndex)
	Props.Put("ox", f.WindowLeft)
	Props.Put("oy", f.WindowTop)
	File.WriteMap(File.DirApp, "properties.map", Props)
End Sub

Public Sub set_encryptmethod
	Main.cbEncryptMethod.Items.AddAll(Array As String("MD5","SHA-1","SHA-224","SHA-256","SHA-384","SHA-512","NONE"))
	Main.cbEncryptMethod.SelectedIndex = Items
	Main.tfString.Text = ""
End Sub

#Region Properties 

'Get or Set the Encryption Method Valid: MD5 SHA-1 SHA-224 SHA-256 SHA-384 SHA-512 NONE
Public Sub getEncryptMethod As String
	Return encrypt_method
End Sub

'Get or Set the Encryption Method Valid: MD5 SHA-1 SHA-224 SHA-256 SHA-384 SHA-512 NONE
Public Sub setEncryptMethod (method As String)
	If method = "MD5" Or method = "SHA-1"  Or method = "SHA-224"  Or method = "SHA-256"  Or method = "SHA-384"  Or method = "SHA-512"  Or method = "NONE" Then
		encrypt_method = method
	Else
		Log("wrong encryption method")
	End If
End Sub

'Get or Set the Salt Value to Secure your User Input more
Public Sub getSalt As String
	Return salt_value
End Sub

'Get or Set the Salt Value to Secure your User Input more
Public Sub setSalt (Salt As String)
	salt_value = Salt
End Sub

Public Sub getemMD5 As String
	Return "MD5"
End Sub

Public Sub getemSHA1 As String
	Return "SHA-1"
End Sub

Public Sub getemSHA224 As String
	Return "SHA-224"
End Sub

Public Sub getemSHA256 As String
	Return "SHA-256"
End Sub

Public Sub getemSHA384 As String
	Return "SHA-384"
End Sub

Public Sub getemSHA512 As String
	Return "SHA-512"
End Sub

Public Sub getemNONE As String
	Return "NONE"
End Sub

#End Region

#Region Genering String to Hash 

Private Sub cbEncryptMethod_SelectedIndexChanged(Index As Int, Value As Object)
	encrypt_method = Value.As(String)
End Sub

Public Sub GeneringString2Hash (input As String) As String
	If encrypt_method = "NONE" Then 
		Return input
	Else
		Dim md As MessageDigest
		Dim generinghash() As Byte
		Dim ByteCon As ByteConverter
  
		generinghash = md.GetMessageDigest(input.GetBytes("UTF8"), encrypt_method)
		Dim HashString As String
		HashString = ByteCon.HexFromBytes(generinghash)
		HashString = HashString.ToUpperCase
		Return HashString
	End If
End Sub

#End Region

#Region Generate Salt 

'Genering the Salt Value to Secure your User Input more
'L=Length salt
Private Sub GenerateSalt (Lg As Int) As String
	Dim su As StringUtils
	Dim bytes(Lg) As Byte
	Private secureRandom1 As SecureRandom
	secureRandom1.GetRandomBytes(bytes)
	Return su.EncodeBase64(bytes).SubString2(0, Lg)
End Sub

#End Region

#Region DiskEvents

'V1.0
'Added new functions have been added to the project

Sub DisksAdded_Event
	Log ("Disk Added")
	
	DiskSerial.getAllDrives
End Sub

Sub DisksRemoved_Event
	Log ("Disk Removed")
	
	B4XDiskUtils.TerminateEvents ' when you no longer need diskEvents in this code module you can terminate then with
	DiskSerial.getAllDrives
End Sub

Private Sub DiskSerial_result(Successful As Boolean, DriveSerial As String)
	Main.tfString.Text = ""
End Sub

Private Sub DiskSerial_drives(Successful As Boolean, DriveNames() As Object)
	Dim counter As Int
	If Successful = True Then
		Main.cbDiskSerial.Items.Clear
		For counter = 0 To DriveNames.Length -1
			Main.cbDiskSerial.Items.Add(DriveNames(counter)&" "&DiskSerial.getSerialNumber(DriveNames(counter)))
		Next
	Else
		Log("No Drives Found")
		Main.cbDiskSerial.Items.Clear
	End If
End Sub

#End Region

#Region Action

'V1.0
'Added new functions have been added to the project

Public Sub ClearSystemClipboard As ResumableSub
	Private myClipBoard As JavaObject
	myClipBoard.InitializeStatic("javafx.scene.input.Clipboard")
	myClipBoard.RunMethodJO("getSystemClipboard",Null).RunMethod("clear",Null)
	Return True
End Sub

#End Region